=== debian/changelog ===
lzfse (1.0-2) unstable; urgency=medium

  * Team upload.

  [ Tobias Heider ]
  * Update VCS links to point to salsa.debian.org
  * Fix VCS-Git format. drop branch, add .git.

  [ NoisyCoil ]
  * CMakeLists.txt: update cmake_minimum_required() (Closes: #1113259)
  * Override description-starts-with-package-name lintian error
  * d/control: set Bananas Team as Maintainer and move tobhe to Uploaders
  * d/control: bump Standards-Version to 4.7.2, no changes needed

 -- NoisyCoil <noisycoil@debian.org>  Sun, 28 Sep 2025 14:07:39 +0200

lzfse (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1055198)

 -- Tobias Heider <me@tobhe.de>  Thu, 02 Nov 2023 09:52:21 +0100
