=== debian/control ===
Source: lzfse
Section: libs
Priority: optional
Maintainer: Debian Bananas Team <team+bananas@tracker.debian.org>
Uploaders:
 Tobias Heider <me@tobhe.de>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-little-endian,
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/lzfse/lzfse
Vcs-Browser: https://salsa.debian.org/bananas-team/lzfse
Vcs-Git: https://salsa.debian.org/bananas-team/lzfse.git
Rules-Requires-Root: no

Package: liblzfse1
Section: libs
Architecture: any
Multi-Arch: same
Breaks:
 liblzfse (<= 1.0-1),
Replaces:
 liblzfse (<= 1.0-1),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: LZFSE Compression library
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.

Package: liblzfse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 liblzfse1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 lzfse-dev (<= 1.0-1),
Replaces:
 lzfse-dev (<= 1.0-1),
Description: LZFSE Compression library (development files)
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.
 .
 This package contains the development files (C headers)

Package: lzfse
Section: misc
Architecture: any
Multi-Arch: foreign
Breaks:
 lzfse-bin (<= 1.0-1),
Replaces:
 lzfse-bin (<= 1.0-1),
Depends:
 liblzfse1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: LZFSE Compression library (command line tool)
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.
 .
 This package contains binary utilities that accompany the library.
